/*******************************
Copyright (c) 2009 Carnegie Mellon

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*********************************/
var elementcode = null;	
var getarg1=0;
var getarg3 = "";
var usapfilterhide = "";
var usapfiltershow = ".usapstatus input[value=1]:checked,.usapstatus input[value=2]:checked,.usapstatus input[value=3]:checked,.usapstatus input[value=4]:checked,.usapstatus input[value=5]:checked"; 
/*************
*	the assumption we are making is that all of the filter boxes start out at checked when
*	the page is loaded - i.e. we do not preserve the filtering boxes from session to session
*************/


/**************
*	in an attempt to work around an apparent threading problem, only
* 	one event at a time will be processed.
*	for each event, we will send to the data base the information from the
*	last event and save the information for the next. Arg1 is 1,2,3 depending on the type of 
*	information, arg3 is the suffix, and element code is used to hold the handle 
*	when an element gets focus
**********/

$(document).ready(
/****
*  these routines respond to events in the usap dependent windows in the main pane
*/
	function(){
/****
*	we start by checking whether the responsibility check boxes should be ticked
*	and then we use that result to see whether the usap box should be ticked
**********/
	$(".responsibilitywrapper").each(function(){
		responsibilitytextcheckbox(this);
		checkboxusap(this);
		})
		
	$(".responsibility-radio").click(function(){
		
	/********
	* select radio button
	*	first action is to make a get for the last event
	*/
		if(elementcode)
			send_data_base_value(getarg1,elementcode,getarg3);
		elementcode = this;
		getarg1 = 1;
		getarg3 = this.value;
		selectedresponsibility = $(this).parents(".responsibilitywrapper");
		responsibilitytextcheckbox(selectedresponsibility)
		checkboxusap(selectedresponsibility);
		})
		
	$(".responsibility-check").click(function(){
	/********
	* select to be discussed check box
	* first item of business is to make a get for the last event
	*/	

		if(elementcode)
			send_data_base_value(getarg1,elementcode,getarg3);
		if(this.checked) {getarg3 = 1;}
			else {getarg3 = 0;}
		elementcode = this;
		getarg1 = 2;
		})
	/********
	* text goes into the notes box. This one is complicated. The text is saved when
	*	either the text box loses focus or the user moves to a different URL (the
	*	text box is unloaded). We keep track of the latest place where focus has been
	*	in elementcode
	*/
	$(".notestext").focus(function()
	{
		/***first we make a get for the last event
		*****/
		if(elementcode)
			send_data_base_value(getarg1,elementcode,getarg3);
		elementcode = this;
		getarg1 = 3;
		getarg3 = 0;})


	/***************************************************
*	these routines are responsible for filtering the usap status boxes depending on the filter check boxes.
*	we construct two strings that we will use to do the filtering: usaphide and usapshow. 
*******************************/
	$(".filteroptionbox").click(function(){
	/* we have a change of one of the filter boxes. We need to
	* 1) call the add and remove filter string routines
	* 2) clear the queue for the data base values
	***********************/
		if (elementcode) send_data_base_value(getarg1,elementcode,getarg3);
		elementcode = null;
		usapfiltershow = filtershowhide(usapfiltershow,this.value, this.checked); 
		usapfilterhide = filtershowhide(usapfilterhide,this.value, !this.checked);
})

	$("#edit-submit[value='Filter']").click(function(){
/*************
*	this is entered when the filter button has been clicked.
*   we use the strings usapfiltershow and usapfilter hide to find the usap boxes
*	that are to be hidden or shown
***************/
		if (elementcode) send_data_base_value(getarg1,elementcode,getarg3);
		elementcode = null;
		$(usapfiltershow).parents(".usapstatus").removeClass('hideusap');
		$(usapfilterhide).parents(".usapstatus").addClass('hideusap');
	/****
	*  we now hide the responsibility text of those boxes that were hidden
	*	we follow this by showing the text of those boxes that are shown
	*	if this does not flicker, we will leave it, otherwise another technique
	*******/
		$(usapfilterhide).parents(".responsibilitywrapper").addClass('hideresponsibility');	
		$(usapfiltershow).parents(".responsibilitywrapper").removeClass('hideresponsibility');		
		return false;
		})
		
		
	$("#edit-rationale").click(function(){
/***
*	this is entered when the show/hide rationale button is pressed. It exposes/hides all of the rationales and changes the 
*   text from show to hide or vice versa
******/
		if (elementcode) send_data_base_value(getarg1,elementcode,getarg3);
		elementcode = null;
		if (this.value == 'Hide Rationales'){
			$(".rationaletext").addClass('hidetext');
			$("#edit-rationale").attr("value","Show Rationales");
			return false;}
		else {
			$(".rationaletext").removeClass('hidetext');
			$("#edit-rationale").attr("value","Hide Rationales");
			return false;}

		})
		
	$("#edit-implementation").click(function(){
/***
*	this is entered when the show/hide implementation details button is pressed. It exposes/hides all of the 
*	implementation details and changes the text from show to hide or vice versa
******/
		if (elementcode) send_data_base_value(getarg1,elementcode,getarg3);
		elementcode = null;
		if (this.value == 'Hide Implementation details'){
			$(".implementationtext").addClass('hidetext');
			$("#edit-implementation").attr("value","Show Implementation details");
			return false;}
		else {
			$(".implementationtext").removeClass('hidetext');
			$("#edit-implementation").attr("value","Hide Implementation details");
			return false;}

		})
		$(window).unload(function(){
		if (elementcode) send_data_base_value(getarg1,elementcode,getarg3);
		elementcode = null;})
		
		$(".rationalelink, .implementationlink").click(function(){
/*************
*	this function is entered when the user clicks the rationale or implementation link and the text is currently hidden
*	it removes the hidetext and adds the showtext (this makes the text visible)
************/

	var textparagraph = $(this).children();
	if(textparagraph.is('.hidetext')) {
		textparagraph.removeClass('hidetext');
	} else {
		textparagraph.addClass('hidetext');
	}
	return false;
	})

function send_data_base_value(arg1,ind,suffix)
/***
*	This function generates a url that results in data being saved in the data base
*	the url is aplusevaluation/1/arg/ind.value/suffix
**********/
	{
	if(ind == null)return false;
	arg3 = suffix;
	if(arg1 == 3) arg3 = ind.value;
	$.get("aplusevaluation/"+arg1+"/"+ind.name+"/"+arg3);
	return false;
}

function filtershowhide(showstring, value, checked)
/******
*	this function maintains the filter string that is shown.
*	if "checked" is true then the string ".usapstatus input[value=value]:checked" is added to the show string
*	if "checked is false, then the same string is removed from the show string
*	in either case, we need to worry about the fact that the selection items are comma separated. 
******************/
{
		valuestring = ".usapstatus input[value=";
		valuestring = valuestring + value;
		valuestring = valuestring + "]:checked";
		result = showstring;
		if(checked) { /* this is the case where we wish to add valuestring to showstring 
						first we worry about the empty string (to enable us to deal with
						commas correctly*/
			if(result != "") result = result + ",";
			result = result + valuestring;}
		else { /* this is the case where we wish to remove valuestring
					we find the location of the string*/
			locat = result.indexOf(valuestring);
			if (locat != 0)locat = locat - 1;   /* if this is not the first entry, 
													then there is a leading comma we need to get rid of*/
			front = result.substr(0,locat);
			locat = locat + 1;					/* we need to correct for the difference between index and length)*/
			back = result.substr(locat+valuestring.length);
			result = front + back;
			}
		return result;
}
function responsibilitytextcheckbox(elem)
{
/************
*	this routine determines whether the check box associated with the responsibility should be checked
*	this happens only if all of the usaps for that responsibility are not "not yet considered"
*	if the number of checked "not yet considered" is 0 then we turn on the check box
************/


		var countchecked = $(elem).find('input[value=1]:checked');
		if (countchecked.length == 0) {
			$(elem).children('input').attr("checked", true);
			return true;
			}
		else {
			$(elem).children("input").attr("checked",false);
			return false;
			}
}
function checkboxusap(elem)
{
/******this routine determines whether the usap check box should be checked and checks it if it should)
*	it is entered with a responsibility wrapper element. This element has an id of xx.yy.zz
*	we remove the .zz and are left with the id of the usap text. We also have the beginning of every
*	responsibility wrapper for this usap. If all of these are checked, we also check the usap box.
******************/
	var elementid = $(elem).attr('id');
	var lastdot = elementid.lastIndexOf(".");
	var usapid = elementid.substr(0,lastdot);
	/* count the number of responsibilities in this usap*/
	var responsibilitycount = $('fieldset[id^='+usapid+']');
	/********now we count how many are checked
	****************/
	var responsibilitychecked = $('fieldset[id^='+usapid+']').children("input:checked");
	if(responsibilitycount.length == responsibilitychecked.length){
		$('div[id='+usapid+']').children('input').attr("checked", true);
		}
		else {
		$('div[id='+usapid+']').children('input').attr("checked", false);}	
}
})

		